﻿Option Strict On
Imports System.Xml.Linq

Public Class PersonalInfo
    Property 氏名 As String
    Property 読み As String
    Property 年齢 As String
    Property 住所 As String
    Property 勤務先 As String
    Property 区切り As String
End Class
Partial Public Class MainPage
    Inherits PhoneApplicationPage

    ' Constructor
    Public Sub New()
        InitializeComponent()
    End Sub

    Private Sub MainPage_Loaded(sender As Object, e As System.Windows.RoutedEventArgs) Handles MyBase.Loaded
        Dim xmldoc As XElement = XElement.Load("sampleData_Group.xml")
        Dim myPersonalInfo As New List(Of PersonalInfo)

        Dim query = From c In xmldoc.Elements("情報") Order By c.Element("読み").Value Group c By c.Element("読み").Value Into yomiGroup = Group

        '読みでグループ化されたresult.yomiGroupコレクション内で、変数result2に各要素を格納していく
        For Each result In query
            For Each result2 In result.yomiGroup
                With myPersonalInfo
                    .Add(New PersonalInfo With {.氏名 = result2.Element("氏名").Value,
                                               .読み = result2.Element("読み").Value,
                                               .年齢 = result2.Element("年齢").Value,
                                               .住所 = result2.Element("住所").Value,
                                               .勤務先 = result2.Element("勤務先").Value,
                                                .区切り = "--------------------------"})
                End With

            Next

        Next

        Dim groupBy = From c In myPersonalInfo Group c By c.読み Into myYomiGroup = Group Select New myGroup(Of PersonalInfo)(myYomi:=読み, myItems:=myYomiGroup)

        LongListSelector1.ItemsSource = groupBy
    
    End Sub

    Public Class myGroup(Of T)
        Implements IEnumerable(Of T)
        Property Yomi As String
        Property Items As IList(Of T)
        Public Sub New(myYomi As String, myItems As IEnumerable(Of T))
            Yomi = myYomi
            Items = New List(Of T)(myItems)
        End Sub

        Public Overrides Function Equals(obj As Object) As Boolean
            Dim selectData As myGroup(Of T) = TryCast(obj, myGroup(Of T))
            Return Yomi.Equals(selectData.Yomi)
        End Function

        Public Function GetEnumerator() As System.Collections.Generic.IEnumerator(Of T) Implements System.Collections.Generic.IEnumerable(Of T).GetEnumerator
            Return Items.GetEnumerator
        End Function

        Public Function GetEnumerator1() As System.Collections.IEnumerator Implements System.Collections.IEnumerable.GetEnumerator
            Return Items.GetEnumerator
        End Function
    End Class
End Class
